library app_store_receipt;

import 'dart:convert';

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'appStoreReceipt.g.dart';

abstract class AppStoreReceipt
    implements Built<AppStoreReceipt, AppStoreReceiptBuilder> {
  AppStoreReceipt._();

  factory AppStoreReceipt([updates(AppStoreReceiptBuilder b)]) =
      _$AppStoreReceipt;

  @BuiltValueField(wireName: 'quantity')
  String get quantity;
  @BuiltValueField(wireName: 'product_id')
  String get productID;
  @BuiltValueField(wireName: 'transaction_id')
  String get transactionID;
  @BuiltValueField(wireName: 'original_transaction_id')
  String get originalTransactionID;
  @BuiltValueField(wireName: 'purchase_date')
  String get purchaseDate;
  @BuiltValueField(wireName: 'purchase_date_ms')
  String get purchaseDateMS;
  @BuiltValueField(wireName: 'purchase_date_pst')
  String get purchaseDatePST;
  @BuiltValueField(wireName: 'original_purchase_date')
  String get originalPurchaseDate;
  @BuiltValueField(wireName: 'original_purchase_date_ms')
  String get originalPurchaseDateMS;
  @BuiltValueField(wireName: 'original_purchase_date_pst')
  String get originalPurchaseDatePST;
  @BuiltValueField(wireName: 'expires_date')
  String get expiresDate;
  @BuiltValueField(wireName: 'expires_date_ms')
  String get expiresDateMS;
  @BuiltValueField(wireName: 'expires_date_pst')
  String get expiresDatePST;
  @BuiltValueField(wireName: 'web_order_line_item_id')
  String get webOrderLineItemID;
  @BuiltValueField(wireName: 'is_trial_period')
  String get isTrialPeriod;
  @BuiltValueField(wireName: 'is_in_intro_offer_period')
  String get isInIntroOfferPeriod;
  @BuiltValueField(wireName: 'in_app_ownership_type')
  String get inAppOwnershipType;
  @BuiltValueField(wireName: 'subscription_group_identifier')
  String get subscriptionGroupIdentifier;
  String toJson() {
    return json
        .encode(serializers.serializeWith(AppStoreReceipt.serializer, this));
  }

  static AppStoreReceipt? fromJson(String jsonString) {
    return serializers.deserializeWith(
        AppStoreReceipt.serializer, json.decode(jsonString));
  }

  static Serializer<AppStoreReceipt> get serializer =>
      _$appStoreReceiptSerializer;
}
