library app_store_receipt_validation_result;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:puma_pay/entities/appStoreReceipt/appStoreReceipt.dart';

import '../../serializers.dart';

part 'appStoreReceiptValidationResult.g.dart';

abstract class AppStoreReceiptValidationResult
    implements
        Built<AppStoreReceiptValidationResult,
            AppStoreReceiptValidationResultBuilder> {
  AppStoreReceiptValidationResult._();

  factory AppStoreReceiptValidationResult(
          [updates(AppStoreReceiptValidationResultBuilder b)]) =
      _$AppStoreReceiptValidationResult;

  @BuiltValueField(wireName: 'environment')
  String? get environment;

  @BuiltValueField(wireName: 'status')
  int get status;

  @BuiltValueField(wireName: 'latest_receipt_info')
  BuiltList<AppStoreReceipt> get latestReceiptInfo;

  String toJson() {
    return json.encode(serializers.serializeWith(
        AppStoreReceiptValidationResult.serializer, this));
  }

  static AppStoreReceiptValidationResult? fromJson(String jsonString) {
    return serializers.deserializeWith(
        AppStoreReceiptValidationResult.serializer, json.decode(jsonString));
  }

  static Serializer<AppStoreReceiptValidationResult> get serializer =>
      _$appStoreReceiptValidationResultSerializer;
}
