library product;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:puma_pay/entities/purchaseDetail/purchaseDetail.dart';

import '../../serializers.dart';

part 'product.g.dart';

abstract class Product implements Built<Product, ProductBuilder> {
  Product._();

  factory Product([updates(ProductBuilder b)]) = _$Product;

  @BuiltValueField(wireName: 'id')
  String get id;
  @BuiltValueField(wireName: 'title')
  String get title;
  @BuiltValueField(wireName: 'description')
  String get description;
  @BuiltValueField(wireName: 'price')
  String get price;
  @BuiltValueField(wireName: 'rawPrice')
  double get rawPrice;
  @BuiltValueField(wireName: 'currencySymbol')
  String get currencySymbol;
  @BuiltValueField(wireName: 'currencyCode')
  String get currencyCode;
  @BuiltValueField(wireName: 'purchaseDetails')
  BuiltList<PurchaseDetail> get purchaseDetails;

  String toJson() {
    return json.encode(serializers.serializeWith(Product.serializer, this));
  }

  static Product? fromJson(String jsonString) {
    return serializers.deserializeWith(
        Product.serializer, json.decode(jsonString));
  }

  static Serializer<Product> get serializer => _$productSerializer;
}
