library purchaseDetail;

import 'dart:convert';

import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:puma_pay/entities/appStoreReceiptValidationResult/appStoreReceiptValidationResult.dart';

import '../../serializers.dart';

part 'purchaseDetail.g.dart';

abstract class PurchaseDetail
    implements Built<PurchaseDetail, PurchaseDetailBuilder> {
  PurchaseDetail._();

  factory PurchaseDetail([updates(PurchaseDetailBuilder b)]) = _$PurchaseDetail;

  @BuiltValueField(wireName: 'purchaseID')
  String? get purchaseID;

  @BuiltValueField(wireName: 'productID')
  String get productID;

  @BuiltValueField(wireName: 'transactionDate')
  String? get transactionDate;

  @BuiltValueField(wireName: 'status')
  String get status;

  @BuiltValueField(wireName: 'valid')
  bool? get valid;

  @BuiltValueField(wireName: 'receipt')
  AppStoreReceiptValidationResult? get receipt;

  String toJson() {
    return json
        .encode(serializers.serializeWith(PurchaseDetail.serializer, this));
  }

  static PurchaseDetail? fromJson(String jsonString) {
    return serializers.deserializeWith(
        PurchaseDetail.serializer, json.decode(jsonString));
  }

  static Serializer<PurchaseDetail> get serializer =>
      _$purchaseDetailSerializer;
}
