import 'package:puma_pay/entities/appStoreReceipt/appStoreReceipt.dart';

extension ExtProduct on AppStoreReceipt {
  bool isValid() {
    DateTime date = this.expirationDate();

    if (date.isBefore(DateTime.now())) {
      return false;
    }

    return true;
  }

  DateTime expirationDate() {
    int millis = int.parse(this.expiresDateMS);

    return new DateTime.fromMillisecondsSinceEpoch(millis);
  }
}
