import 'package:flutter/material.dart';
import 'package:in_app_purchase/in_app_purchase.dart';
import 'package:puma_pay/entities/product/product.dart';
import 'package:puma_pay/entities/purchaseDetail/purchaseDetail.dart';
import 'package:puma_pay/extensions/extPurchaseDetail.dart';

extension ExtProduct on Product {
  toProductDetail() {
    return ProductDetails(
      id: this.id,
      title: this.title,
      description: this.description,
      price: this.price,
      rawPrice: this.rawPrice,
      currencySymbol: this.currencySymbol,
      currencyCode: this.currencyCode,
    );
  }

  bool isValid() {
    for (var purchaseDetail in this.purchaseDetails) {
      if (purchaseDetail.isValid()) {
        return true;
      }
    }
    return false;
  }

  String isValidString() {
    for (var purchaseDetail in this.purchaseDetails) {
      if (purchaseDetail.isValidInt() >= 0) {
        return purchaseDetail.isValidString();
      }
    }
    return "Expired";
  }

  Color validColor() {
    for (var purchaseDetail in this.purchaseDetails) {
      if (purchaseDetail.isValidInt() >= 0) {
        return purchaseDetail.validColor();
      }
    }
    return Colors.red;
  }

  PurchaseDetail? validPurchaseDetail() {
    for (var purchaseDetail in this.purchaseDetails) {
      if (purchaseDetail.valid ?? false) return purchaseDetail;
    }
    return null;
  }
}
