import 'package:flutter/material.dart';
import 'package:puma_pay/entities/purchaseDetail/purchaseDetail.dart';

extension ExtPurchaseDetails on PurchaseDetail {
  PurchaseDetail toPurchaseDetailEntity() {
    final _purchaseDetailBuilder = PurchaseDetailBuilder();
    _purchaseDetailBuilder.productID = this.productID;
    _purchaseDetailBuilder.purchaseID = this.purchaseID;
    _purchaseDetailBuilder.status = this.status.toString();
    _purchaseDetailBuilder.transactionDate = this.transactionDate;
    final _purchaseDetail = _purchaseDetailBuilder.build();

    return _purchaseDetail;
  }

  String isValidString() {
    if (this.valid == true) return "Valid";
    if (this.valid == null) return "Valid but not verified";

    return "Expired";
  }

  Color validColor() {
    if (this.valid == true) return Colors.green;
    if (this.valid == null) return Colors.orange;

    return Colors.red;
  }

  int isValidInt() {
    if (this.valid == true) return 1;
    if (this.valid == null) return 0;

    return -1;
  }

  bool isValid() {
    return isValidInt() >= 0;
  }
}
