import 'dart:async';

import 'package:in_app_purchase/in_app_purchase.dart';
import 'package:puma_pay/paymentService.dart';
import 'package:redux/redux.dart';

class StreamSubscriptionSingleton {
  static final StreamSubscriptionSingleton _singleton =
      StreamSubscriptionSingleton._internal();

  StreamSubscription<dynamic>? subscription;

  bool initialized = false;

  init(Store store) {
    subscription?.cancel();
    print("🥚 Init: $initialized ");
    final Stream purchaseUpdated = InAppPurchase.instance.purchaseStream;
    initialized = true;
    print("👂 Listening to purchase updates ");
    subscription = purchaseUpdated.listen((purchaseDetailsList) {
      listenToPurchaseUpdated(purchaseDetailsList, store);
    },
        onError: (e) => print("🚫 An error has occured: $e"),
        onDone: () => print("Sub Done"),
        cancelOnError: true);
  }

  StreamSubscription<dynamic>? getSubscription() {
    return subscription;
  }

  factory StreamSubscriptionSingleton() {
    return _singleton;
  }

  StreamSubscriptionSingleton._internal();
}
