import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:puma_pay/entities/appStoreReceipt/appStoreReceipt.dart';
import 'package:puma_pay/extensions/extAppStoreReceipt.dart';

class AppStoreReceiptTile extends StatelessWidget {
  final AppStoreReceipt receipt;

  AppStoreReceiptTile({
    Key? key,
    required this.receipt,
  }) : super(key: key);

  Text BlackText(String text) {
    return Text(
      text,
      style: TextStyle(
        color: Colors.black,
      ),
    );
  }

  Widget build(BuildContext context) {
    var format = new DateFormat("yMd");

    return Column(
      children: [
        Text(
          "Receipt",
          style: TextStyle(
            color: Colors.black,
            fontWeight: FontWeight.bold,
          ),
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            BlackText("Ownership Type"),
            BlackText(receipt.inAppOwnershipType),
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            BlackText("Expiration Date"),
            BlackText(
              format.format(
                receipt.expirationDate(),
              ),
            ),
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            BlackText("Valid"),
            BlackText(
              receipt.isValid().toString(),
            ),
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            BlackText("Intro Offer Period"),
            BlackText(receipt.isInIntroOfferPeriod),
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            BlackText("Trial Period"),
            BlackText(receipt.isTrialPeriod),
          ],
        ),
        Row(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            BlackText("Quantity"),
            BlackText(receipt.quantity),
          ],
        ),
      ],
    );
  }
}
