import 'package:flutter/material.dart';
import 'package:intl/intl.dart';
import 'package:puma_pay/entities/purchaseDetail/purchaseDetail.dart';
import 'package:puma_pay/extensions/extPurchaseDetail.dart';

class PurchaseDetailTile extends StatelessWidget {
  final PurchaseDetail purchaseDetail;
  final void Function()? onTap;

  PurchaseDetailTile({
    Key? key,
    required this.purchaseDetail,
    this.onTap,
  }) : super(key: key);

  Widget build(BuildContext context) {
    var format = new DateFormat("yMd");

    return ListTile(
      onTap: onTap,
      leading: Column(
        mainAxisAlignment: MainAxisAlignment.start,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          if (purchaseDetail.transactionDate != null)
            Text(
              "${format.format(
                DateTime.fromMillisecondsSinceEpoch(
                  int.parse(purchaseDetail.transactionDate!),
                ),
              )}",
            ),
          Text(
            "Purchase ID: ${purchaseDetail.purchaseID}",
            style: Theme.of(context).textTheme.caption,
          ),
        ],
      ),
      trailing: Column(
        crossAxisAlignment: CrossAxisAlignment.end,
        children: [
          Text(
            purchaseDetail.isValidString(),
            style: TextStyle(
              fontWeight: FontWeight.bold,
              color: purchaseDetail.validColor(),
            ),
          ),
        ],
      ),
    );
  }
}
